SystemOrganization addCategory: #Spec!
SystemOrganization addCategory: #'Spec-Browsers'!
SystemOrganization addCategory: #'Spec-Examples'!
SystemOrganization addCategory: #'Spec-Tests'!

!Morph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/14/2011 16:32'!
addMorphWrapper: aMorphWrapper
	
	
	aMorphWrapper addIn: self.! !

PanelMorph subclass: #TabContainerMorph
	instanceVariableNames: 'container tab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!TabContainerMorph commentStamp: '<historical>' prior: 0!
A TabContainerMorph is a morph (which should be pluggable soon) which handle a first bar for tabs button and a container which is used to display the morph corresponding to the selected tab!

!TabContainerMorph class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 1/9/2012 17:46'!
example

	| tc testMorph model model2 model3 anotherMorph anotherMorph2 associations holder |
	
	model := ClassMethodBrowser new.
	model2 := ClassMethodList new.
	model3 := ClassMethodList new.
	
	testMorph := model buildWithSpec: #internSpec.
	anotherMorph := model2 buildWithSpec: #internSpec.
	anotherMorph2 := model3 buildWithSpec: #internSpec.
	
	associations := {'Test' -> testMorph. 'Another'-> anotherMorph. 'Again' -> anotherMorph2}.
	tc := self withTabs: associations.
	holder := (Smalltalk allClasses) asValueHolder.
	model listHolder: holder .
	model2 listHolder: holder.
	model3 listHolder: holder.
	
	( tc embeddedInMorphicWindowLabeled: 'test') openInWorld.
	^ tc! !

!TabContainerMorph class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/7/2012 06:04'!
withTabs: associations

	^ self new
		addTabs: associations;
		yourself.! !

!TabContainerMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/7/2012 06:09'!
addAll
	
	self
		addMorph: tab
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ 35)).
				
	self
		addMorph: container
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 35 corner: 0 @ 0)).! !

!TabContainerMorph methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/7/2012 06:02'!
addTabs: associations

	associations do: [:each |
		self tab 
			addTab: (Text fromString: each key) 
			withAction: [ self setContent: each value ].
		container submorphs isEmpty ifTrue: [ container addMorph: each value ]]! !

!TabContainerMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/7/2012 06:08'!
container

	^ container! !

!TabContainerMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/7/2012 06:14'!
initialize
	"Initialization code for TabContainerMorph"

	super initialize.
	
	self changeProportionalLayout.
	container := PanelMorph new changeTableLayout; listDirection: #bottomToTop; color: Color white; yourself.
	
	tab := PluggableTabBarMorph on: self.
	tab width: 150.
	tab color: Color white darker darker.
	
	self addAll.! !

!TabContainerMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/9/2012 18:43'!
setContent: aMorph

	container removeAllMorphs.
	container addMorph: aMorph.
	aMorph color: Color white.
	aMorph takeKeyboardFocus.! !

!TabContainerMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/7/2012 06:08'!
tab

	^ tab! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 1/19/2012 18:04'!
getIndexSelector: aSelector

	getIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 22:19'!
initialize

	super initialize.
	self initForKeystrokes.! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 1/19/2012 18:04'!
setIndexSelector: aSelector

	setIndexSelector := aSelector! !

Announcement subclass: #ValueChanged
	instanceVariableNames: 'newContents oldContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ValueChanged commentStamp: '<historical>' prior: 0!
A ValueChanged is an announcement raised when a value of a NewValueHolder is changed!

!ValueChanged class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:34'!
newContents: newContents

	^ self new
		newContents: newContents;
		yourself! !

!ValueChanged class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:26'!
oldContents: oldContent newContents: newContent

	^ self new
		newContents: newContent;
		oldContents: oldContent;
		yourself! !

!ValueChanged methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:27'!
newContents: anObject
	
	newContents := anObject! !

!ValueChanged methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:27'!
oldContents: anObject
	
	oldContents := anObject! !

!LayoutFrame methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 1/18/2012 01:57'!
fractions: fractionsOrNil offsets: offsetsOrNil

	| fractions offsets |

	fractions := fractionsOrNil ifNil: [0@0 extent: 0@0].
	offsets := offsetsOrNil ifNil: [0@0 extent: 0@0].
	
	^self
		topFraction: fractions top offset: offsets top;
		leftFraction: fractions left offset: offsets left;
		bottomFraction: fractions bottom offset: offsets bottom;
		rightFraction: fractions right offset: offsets right
! !

TestCase subclass: #SpecInterpreterTest
	instanceVariableNames: 'specInterpreter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!SpecInterpreterTest commentStamp: '<historical>' prior: 0!
A SpecInterpreterTest is a test class for testing the behavior of SpecInterpreter!

!SpecInterpreterTest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/19/2012 16:28'!
setUp
	"Setting up code for SpecInterpreterTest"


	specInterpreter := SpecInterpreter new.! !

!SpecInterpreterTest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/19/2012 15:57'!
tearDown
	"Tearing down code for SpecInterpreterTest"


	specInterpreter := nil.! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 17:34'!
testBuildMorphFor

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildMorphFor: model.
	
	self assert: (morph model == model).
	self assert: (model morph class = PluggableListMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 17:35'!
testBuildMorphForWithSpec

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildMorphFor: model withSpec: #testingSpec.
	
	self assert: (morph model == model).
	self assert: (model morph class = PluggableTextMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 17:40'!
testBuildWindowFor

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildWindowFor: model.
	
	self assert: ( model morph = morph).
	self assert: (morph submorphs anySatisfy: [:e | e class = PluggableListMorph ])! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 16:34'!
testConvertRandomSymbolOfClassToInstance
	
	| symbol instance |
	symbol := #PluggableListMorph.
	
	instance := specInterpreter convertSymbolOfClassToInstance: symbol.
	self assert: (instance class name = symbol)! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
testConvertSymbolOfClassToInstance
	
	| association instance|
	association := specInterpreter bindings associations first.
	
	instance := specInterpreter convertSymbolOfClassToInstance: association key.
	self assert: (instance class name = association value)! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 16:03'!
testInterpretASpecModel

	| spec model morph |
	model := ComposableModel new.
	spec := {#PluggableListMorph. #model:. #model}.
	morph := specInterpreter interpretASpec: spec model: model.
	
	self assert: (morph model == model).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 16:28'!
testInterpretASpecModelMorphAssociation

	| spec model morph |
	model := ComposableModel new.
	spec := {#PluggableListMorph. #model:. #model}.
	morph := specInterpreter interpretASpec: spec model: model.
	
	self assert: (model morph == morph).! !

Object subclass: #ComposableModel
	instanceVariableNames: 'morph focusOrder owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ComposableModel commentStamp: '<historical>' prior: 0!
ComposableModel is an abstract which represent a applicative model made to be composed with other ComposableModel!

ComposableModel subclass: #ButtonModel
	instanceVariableNames: 'actionHolder labelHolder stateHolder enabledHolder actionPerformedHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ButtonModel commentStamp: '<historical>' prior: 0!
A ButtonComposableModel is an applicative model which handle a basic button.

| b |
b:= ButtonComposableModel new.
b openWithSpec.
b labelHolder contents: 'Click me'.

self example!

!ButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/1/2012 13:44'!
internSpec

	^ {#PluggableButtonMorph.
	    		#on:getState:action:label:menu:. 	#model. #state. #action. #label. #nil.
			#getEnabledSelector:. 				#enabled.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!ButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/15/2011 14:42'!
title

	^ 'Button'! !

!ButtonModel methodsFor: 'morphic' stamp: 'SimonAllier 1/27/2012 11:42'!
action

	self morph ifNotNil: [:m | m takeKeyboardFocus ].
	self actionHolder contents value.
	" Here I set a dummy value just to make the holder raise an event "
	self actionPerformedHolder contents: nil.! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 01:33'!
action: aBlock

	self actionHolder contents: aBlock! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
actionHolder

	^ actionHolder! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
actionHolder: anObject
	
	actionHolder := anObject! !

!ButtonModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 11:40'!
actionPerformedHolder
" I am a dummy holder used to announce that my action has been performed "
	^ actionPerformedHolder! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/15/2011 14:48'!
enabled

	^ self enabledHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 11:47'!
enabled: aBoolean
	
	^ self enabledHolder contents: aBoolean! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:47'!
enabledHolder

	^ enabledHolder! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:47'!
enabledHolder: anObject
	
	enabledHolder := anObject.
	anObject whenChangedDo: [ self changed: #enabled ].
	self changed: #enabled! !

!ButtonModel methodsFor: 'initialization' stamp: 'SimonAllier 1/27/2012 11:43'!
initialize
	"Initialization code for ButtonComposableModel"

	super initialize.

	self actionHolder: [] asValueHolder.
	self labelHolder: '' asValueHolder.
	self stateHolder: true asValueHolder.
	self enabledHolder: true asValueHolder.

	actionPerformedHolder := nil asValueHolder! !

!ButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/18/2012 01:46'!
isEventForNextFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<right>'! !

!ButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/18/2012 01:46'!
isEventForPreviousFocus: aKeyboardEvent 

	^ aKeyboardEvent keyString  = '<left>'! !

!ButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/23/2012 19:03'!
keyStroke: anEvent fromMorph: aMorph

	anEvent keyString = '<space>'
		ifTrue: [ self action ].
		
	super keyStroke: anEvent fromMorph: aMorph! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/15/2011 14:28'!
label

	^ self labelHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 00:33'!
label: aString

	self labelHolder contents: aString! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
labelHolder

	^ labelHolder! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:40'!
labelHolder: anObject
	
	labelHolder := anObject.
	anObject whenChangedDo: [ self changed: #label ].
	self changed: #label! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/15/2011 14:10'!
state

	^ self stateHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 00:59'!
state: aBoolean
	
	^ self stateHolder contents: aBoolean! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
stateHolder

	^ stateHolder! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:45'!
stateHolder: anObject
	
	stateHolder := anObject.
	anObject whenChangedDo: [ self changed: #state ].
	self changed: #state! !

!ButtonModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 11:41'!
whenActionPerformedDo: aBlock

	self actionPerformedHolder whenChangedDo: aBlock! !

ComposableModel subclass: #CheckBoxExample
	instanceVariableNames: 'button1 button2 button3 container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!CheckBoxExample commentStamp: '<historical>' prior: 0!
A CheckBoxExample is a simple example of how to use CheckBoxes!

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
internSpec

	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		self topSpec.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	(0@0 corner: 1@0).	(0@0 corner: 0@20). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #container.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@1).	(0@22 corner: 0@0). }}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
internSpec2

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.	#internSpec}.
			#addMorph:. {#model.	#button2.	#internSpec}.
			#addMorph:. {#model.	#button3.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
title

	^ 'Radio Button Group Example'! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
topSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.	#internSpec}.
			#addMorph:. {#model.	#button2.	#internSpec}.
			#addMorph:. {#model.	#button3.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button1

	^ button1! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button2

	^ button2! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button3

	^ button3! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
container

	^ container! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:03'!
initialize
	"Initialization code for RadioButtonGroupExample"

	super initialize.

	self instantiateButtons.
	container := PanelMorph new.
	
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	self instantiateMorphs.
	self setFocus.
	self setActions.
	! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 09:30'!
instantiateButtons

	button1 := self instantiate: CheckBoxModel.
	button2 := self instantiate: CheckBoxModel.
	button3 := self instantiate: CheckBoxModel.
	
	button1 label: 'Button 1'.
	button2 label: 'Button 2'.
	button3 label: 'Button 3'.! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActions

	self setActionsForButton1.
	self setActionsForButton2.
	self setActionsForButton3.	! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton1

	button1 whenActivatedDo: [ container addMorph: morph1 ].
	button1 whenDesactivatedDo: [ container removeMorph: morph1 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton2

	button2 whenActivatedDo: [ container addMorph: morph2 ].
	button2 whenDesactivatedDo: [ container removeMorph: morph2 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton3

	button3 whenActivatedDo: [ container addMorph: morph3 ].
	button3 whenDesactivatedDo: [ container removeMorph: morph3 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setFocus
	
	self focusOrder
		add: button1;
		add: button2;
		add: button3.
	! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setGroup

	RadioButtonGroup new 
		addRadioButton: button1;
		addRadioButton: button2;
		addRadioButton: button3;
		default: button1.
	! !

ComposableModel subclass: #CheckBoxModel
	instanceVariableNames: 'actionWhenActivatedHolder actionWhenDesactivatedHolder enabledHolder stateHolder label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!CheckBoxModel commentStamp: '<historical>' prior: 0!
A CheckboxModel is a spec model for Checkbox

The method privateSetState: is really private and should only be used by RadioButtonGroup

You can see self>>#example for an example

You can also have a look at CheckBoxExample for a full example of how to use them with a group.
!

!CheckBoxModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:07'!
internSpec

	^ {#CheckboxMorph.
	    		#on:selected:changeSelected:. 	#model. #state. #state:.
			#label:.								{	#model. #label		}.
			#beCheckbox.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!CheckBoxModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
title

	^ 'Radio Button'! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
actionWhenActivatedHolder
	
	^ actionWhenActivatedHolder! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
actionWhenDesactivatedHolder
	
	^ actionWhenDesactivatedHolder! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
activationAction: aBlock

	"This method is used to set the action to perform when I am activated"
	self actionWhenActivatedHolder contents: aBlock! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
desactivationAction: aBlock

	"This method is used to set the action to perform when I am desactivated"
	self actionWhenDesactivatedHolder contents: aBlock! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
enabled: aBoolean

	self enabledHolder contents: aBoolean! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
enabledHolder
	
	^ enabledHolder! !

!CheckBoxModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:07'!
initialize
	"Initialization code for RadioButton"

	super initialize.
	
	actionWhenActivatedHolder := [] asValueHolder.
	actionWhenDesactivatedHolder := [] asValueHolder.
	enabledHolder := true asValueHolder.
	stateHolder := false asValueHolder.
	stateHolder whenChangedDo: [:bool |
		bool
			ifTrue: actionWhenActivatedHolder contents
			ifFalse: actionWhenDesactivatedHolder contents ].! !

!CheckBoxModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
isEventForNextFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<right>'! !

!CheckBoxModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
isEventForPreviousFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<left>'! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
label
	
	^ label! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
label: aString

	label := aString.
	self morph
		ifNotNil: [:m | m label: label ]! !

!CheckBoxModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
state

	^ self stateHolder contents! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:07'!
state: aBoolean

	self stateHolder contents: aBoolean! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
stateHolder
	
	^ stateHolder! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
whenActivatedDo: aBlock

	"This method is used to propagate the event that I have been activated" 
	self stateHolder whenChangedDo: [:bool | bool ifTrue: aBlock ]! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
whenDesactivatedDo: aBlock

	"This method is used to propagate the event that I have been desactivated"
	self stateHolder whenChangedDo: [:bool | bool ifFalse: aBlock ]! !

ComposableModel subclass: #ClassMethodBrowser
	instanceVariableNames: 'listModel methodModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!ClassMethodBrowser commentStamp: '<historical>' prior: 0!
A ClassMethodBrowser is a simple browser using spec and reusing MethodBrowser to browse classes>>methods>>sourceCode.
	| cb |
	cb := ClassMethodBrowser new.
	cb openWithSpec.
	cb classes: Smalltalk allClasses.!

!ClassMethodBrowser class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/2/2012 13:39'!
example

	"self example"
	| cb |
	cb := ClassMethodBrowser new.
	cb openWithSpec.
	cb classes: Smalltalk allClasses.! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 13:41'!
internSpec
	| halfsize |
	halfsize := 12.
	^ { #PanelMorph.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #listModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 ( 0@0 corner: 0.5@0.5 ).	(0@0 corner: 0@(halfsize negated)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #methodModel. #listModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	( 0.5@0 corner: 1@0.5 ).	(0@0 corner: 0@(halfsize negated)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #methodModel. #toolbarModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@0.5).	(0@(halfsize negated) corner: 0@halfsize). }}.										
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #methodModel. #textModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@1).	(0@halfsize corner: 0@0). }}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/31/2012 14:46'!
internSpec2

	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #methodModel. #listModel. #internSpec.}.
											#frame:. 	( 0@0 corner: 0.5@0.5 )}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #listModel. #internSpec.}.
											#frame:. 	( 0.5@0 corner: 1@0.5 )}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #methodModel. #textModel. #internSpec.}.
											#frame:.	( 0@0.5 corner: 1@1 )}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/14/2011 18:12'!
title

	^ 'Class Method Browser'! !

!ClassMethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/15/2012 22:53'!
classes: aList

	self listHolder contents: aList! !

!ClassMethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/31/2012 13:15'!
initialize
	"Initialization code for ClassMethodBrowser"

	super initialize.

	listModel := self instantiate: ListComposableModel.
	methodModel := self instantiate: MethodBrowser.
	
	self focusOrder
		add: listModel;
		add: methodModel.
	
	listModel whenSelectedItemChanges: [:selection |
		selection 
			ifNotNil: [:class | 
				methodModel methods: (class methodDict values sort: [:a :b | a selector < b selector]).
				methodModel listModel resetSelection ]].
	
	methodModel wrapWith: [:method | method selector ].! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/15/2012 22:35'!
listHolder

	^ listModel listHolder! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/15/2012 22:35'!
listHolder: anHolder
	
	listModel listHolder: anHolder! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
listModel

	^ listModel! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
methodModel

	^ methodModel! !

ComposableModel subclass: #ClassMethodList
	instanceVariableNames: 'listModel listModel2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!ClassMethodList commentStamp: '<historical>' prior: 0!
| t |
t:= ClassMethodList new.
t openWithSpec.
t listHolder contents: (Smalltalk allClasses).
self example.!

!ClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2012 22:13'!
internSpec

	^{ #PanelMorph.
			#changeTableLayout.
			#listDirection:. #rightToLeft.
			#addMorph:. {#model. #listModel. #internSpec.}.
			#addMorph:. {#model. #listModel2. #internSpec.}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!ClassMethodList classSide methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/7/2012 06:20'!
internSpec2

	^{ #PanelMorph.
			#changeProportioanleLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel. #internSpec.	}.
											#frame:.	(	0@0 corner: 0.5@1)	}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel2. #internSpec.	}.
											#frame:.	(	0.5@0 corner: 1@1)	}.
			#hResizing:. 			#spaceFill.
			#vResizing:. 			#spaceFill}! !

!ClassMethodList classSide methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 11/17/2011 19:44'!
miniSpec

	^ { 	#model. #listModel. #windowSpec.	}! !

!ClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:56'!
title

	^ 'Class Method List'! !

!ClassMethodList classSide methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 11/17/2011 21:12'!
windowSpec2

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel. #windowSpec.	}.
											#frame:.	(	0@0 corner: 0.5@1)	}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel2. #windowSpec.	}.
											#frame:.	(	0.5@0 corner: 1@1)	}.
			#title:.					'Test'											}! !

!ClassMethodList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 1/16/2012 00:50'!
initialize
	| listHolder2 |
	
	super initialize.

	listModel := ListComposableModel new.	
	listModel2 := ListComposableModel new.
	
	listHolder2 := ComposableValueHolder on: (listModel selectionHolder) do: [:index :selection | selection contents ifNotNil: [:c | c methodDict keys sort ]].
	
	listModel2 listHolder: listHolder2.
	
	listModel selectionHolder whenChangedDo: [ listModel2 resetSelection ].! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/15/2012 22:34'!
listHolder

	^ listModel listHolder! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/15/2012 22:34'!
listHolder: anObject

	listModel listHolder: anObject.! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel

	^ listModel! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel2

	^ listModel2! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel2: anObject
	
	listModel2 := anObject! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel: anObject
	
	listModel := anObject! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:52'!
selectionHolder

	^ listModel selectionHolder! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:52'!
selectionHolder: anObject
	
	listModel selectionHolder: anObject! !

ComposableModel subclass: #CodeBrowser
	instanceVariableNames: 'listHolder listModel sendersModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Browsers'!

!CodeBrowser commentStamp: '<historical>' prior: 0!
A CodeBrowser is a simple code browser.


It's composed of a list for classes, and a method browser.!

!CodeBrowser classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/12/2012 19:42'!
internSpec

	^ { #PanelMorph.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{ #model.	#listModel.		#internSpec.}.
											#frame:.	(0@0 corner: 0.5@0.5).
									}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ #model.	#sendersModel.	#listModel.		#internSpec.}.
											#frame:.	(0.5@0 corner: 1@0.5).
									}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ #model.	#sendersModel.	#textModel.	#internSpec.}.
											#frame:. 	(0@0.5 corner: 1@1).
									}}! !

!CodeBrowser classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/12/2012 19:43'!
title

	^ 'Code Browser'! !

!CodeBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/12/2012 19:47'!
initialize
	"Initialization code for CodeBrowser"
	| linkHolder |

	super initialize.

	listHolder := {} asValueHolder.
	listModel := ListComposableModel new.
	sendersModel := SendersBrowser new.
	
	listModel listHolder: listHolder.
	linkHolder := ComposableValueHolder on: listModel selectionHolder do: [:index :selection |
		selection contents
			ifNil: [ {} ]
			ifNotNil: [:class | class methodDict values sort: [:a :b | a selector < b selector ]]].
	sendersModel listHolder: linkHolder.
	sendersModel listModel wrapHolder contents: [:aMethod| aMethod selector ].! !

!CodeBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/12/2012 19:40'!
listHolder

	^ listHolder! !

!CodeBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/12/2012 19:40'!
listHolder: anObject
	
	listHolder := anObject! !

!CodeBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/12/2012 19:40'!
listModel

	^ listModel! !

!CodeBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/12/2012 19:40'!
listModel: anObject
	
	listModel := anObject! !

!CodeBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/12/2012 19:40'!
sendersModel

	^ sendersModel! !

!CodeBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/12/2012 19:40'!
sendersModel: anObject
	
	sendersModel := anObject! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:57'!
internSpec

	^ self subclassresponsibility! !

!ComposableModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/17/2012 03:20'!
owner: owner

	^ self new
		owner: owner;
		yourself! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:07'!
title
	
	^ 'Untitled window'! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:08'!
windowSpec

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	self internSpec.
											#frame:.	(	0@0 corner: 1@1)	}.
			#title:.					self title}! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/1/2012 18:24'!
addAll: aWindow withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		frame: (0@0 corner: 1@1).! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:38'!
buildWithSpec

	^ self buildWithSpec: #internSpec! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:25'!
buildWithSpec: aSpec

	^ SpecInterpreter buildMorphFor: self withSpec: aSpec! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/17/2012 17:40'!
focusOrder

	^ focusOrder ifNil: [ focusOrder := OrderedCollection new ].! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/18/2012 02:10'!
giveFocusToNextFrom: aMorph

	| focus |
	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index next |
			index := (focus indexOf: aMorph) + 1.
			(index <= focus size)
				ifTrue: [
					next := focus at: index.
					^ next takeKeyboardFocus ]].

	owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: 1 ifAbsent: [ ^ self ].
			next takeKeyboardFocus ]
		ifNotNil: [ owner giveFocusToNextFrom: self ]! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/23/2012 19:18'!
giveFocusToPreviousFrom: aMorph 

	| focus |
	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index previous |
			index := (focus indexOf: aMorph) - 1.
			(index > 0)
				ifTrue: [
					previous := focus at: index.
					^ previous takeLastKeyboardFocus ]].

	owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: focus size ifAbsent: [ ^ self ].
			next takeLastKeyboardFocus ]
		ifNotNil: [ owner giveFocusToPreviousFrom: self ]! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/18/2012 01:31'!
handlesKeyboard: evt

	^ true! !

!ComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/31/2012 13:15'!
instantiate: aComposableModelClass

	^ aComposableModelClass owner: self! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:13'!
internSpec

	^ self class internSpec! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 18:40'!
isEventForNextFocus: aKeyboardEvent

	^ false! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 18:40'!
isEventForPreviousFocus: aKeyboardEvent 
	
	^ false! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/4/2012 11:25'!
keyStroke: anEvent fromMorph: aMorph

	(self isEventForNextFocus: anEvent)
		ifTrue: [ ^ self giveFocusToNextFrom: aMorph ].
		
	(self isEventForPreviousFocus: anEvent)
		ifTrue: [ ^ self giveFocusToPreviousFrom: aMorph ].
		
	^ false! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph

	^ morph! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph: anObject
	
	morph := anObject! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/21/2011 13:33'!
openMorphWithSpec

	^ self buildWithSpec openInWorld! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:26'!
openWithSpec

	^ self openWithSpec: #internSpec.! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:27'!
openWithSpec: aSpec
	| window |

	window := StandardWindow new.
	self addAll: window withSpec: aSpec.
	window openInWorld.
	window title: self title.
	self takeKeyboardFocus.
	^ window! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/17/2012 18:31'!
owner: anObject
	
	owner := anObject! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/18/2012 02:10'!
takeKeyboardFocus

	self focusOrder ifNotEmpty:[:focus | ^ focus first takeKeyboardFocus ].
	^ self morph ifNotNil: [:m | m takeKeyboardFocus ]! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 19:51'!
takeLastKeyboardFocus

	self focusOrder
		ifEmpty: [ self takeKeyboardFocus ]
		ifNotEmpty: [:focus | focus last takeKeyboardFocus ].! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/21/2011 13:32'!
title

	^ self class title! !

ComposableModel subclass: #DoubleClassMethodList
	instanceVariableNames: 'classMethodList classMethodList2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!DoubleClassMethodList commentStamp: '<historical>' prior: 0!
| t |
t:= DoubleClassMethodList new.
t openWithSpec.
t listHolder contents: (Smalltalk allClasses).
self example!

!DoubleClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:58'!
internSpec

	^{ #PanelMorph.
			#changeTableLayout.
			#listDirection:. #bottomToTop.
			#addMorph:. {#model. #classMethodList. #internSpec.}.
			#addMorph:. {#model. #classMethodList2. #internSpec.}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!DoubleClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:09'!
title

	^ 'Double double lists'! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList

	^ classMethodList! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList2

	^ classMethodList2! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList2: anObject
	
	classMethodList2 := anObject! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList: anObject
	
	classMethodList := anObject! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:30'!
initialize
	| listHolder2 |

	super initialize.

	classMethodList := ClassMethodList new.
	classMethodList2 := ClassMethodList new.
	
	listHolder2 := ComposableValueHolder 
						on: (classMethodList selectionHolder)
						do: [:index :selection | 
							selection contents 
								ifNotNil: [:c | 
									Smalltalk allClasses select:[:e | e category = c category ]]].
	
	classMethodList2 listHolder: listHolder2! !

!DoubleClassMethodList methodsFor: 'entry point' stamp: 'BenjaminVanRyseghem 1/15/2012 22:32'!
listHolder

	^ classMethodList listHolder! !

!DoubleClassMethodList methodsFor: 'entry point' stamp: 'BenjaminVanRyseghem 1/15/2012 22:32'!
listHolder: aValueHolder

	classMethodList listHolder: aValueHolder! !

ComposableModel subclass: #DropListExample
	instanceVariableNames: 'dropList container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!DropListExample commentStamp: '<historical>' prior: 0!
A DropListExample is a simple example of how to use drop lists.

DropListExample new openWithSpec!

!DropListExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 15:37'!
internSpec

	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		self topSpec.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	(0@0 corner: 1@0).	(0@0 corner: 0@40). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #container.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@1).	(0@42 corner: 0@0). }}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!DropListExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
title

	^ 'Radio Button Group Example'! !

!DropListExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 15:36'!
topSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#dropList.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
blueMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph2 ]! !

!DropListExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
container

	^ container! !

!DropListExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 15:36'!
dropList

	^ dropList! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
greenMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph3 ]! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:47'!
initialize
	"Initialization code for RadioButtonGroupExample"

	super initialize.

	container := PanelMorph new.
	self instantiateMorphs.
	self instantiateDropList.
	
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	self setFocus.
	! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:37'!
instantiateDropList

	| item1 item2 item3 |

	dropList := self instantiate: DropListModel.	
	item1 := DropListItem named: 'Red morph' do: self redMorphBlock.
	item2 := DropListItem named: 'Blue morph' do: self blueMorphBlock.
	item3 := DropListItem named: 'Green morph' do: self greenMorphBlock.
	
	dropList items: {item1. item2. item3}! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
redMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph1 ]! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:26'!
setFocus
	
	self focusOrder
		add: dropList;
		add: container.
	! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
setGroup

	RadioButtonGroup new 
		addRadioButton: button1;
		addRadioButton: button2;
		addRadioButton: button3;
		default: button1.
	! !

ComposableModel subclass: #DropListModel
	instanceVariableNames: 'listHolder selectionHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!DropListModel commentStamp: '<historical>' prior: 0!
A DropListModel is a Spec model for drop lists.

I am assume there is a little problem on an empty list, but frankly, who creates an empty drop list ?!

!DropListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 11:03'!
internSpec

	^ {#DropList.
	    		#on:list:selected:changeSelected:. 	#model. #getList. #getIndex. #setIndex:.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!DropListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 13:21'!
title

	^ 'Drop List'! !

!DropListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 13:33'!
getIndex

	^ self selectionHolder index contents! !

!DropListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 14:45'!
getList

	^ self listHolder contents collect: #label! !

!DropListModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 14:51'!
initialize
	"Initialization code for DropListModel"

	super initialize.

	listHolder := {} asValueHolder.
	selectionHolder := SelectionValueHolder new.
	
	listHolder whenChangedDo: [ 
					self changed: #getList.
					self internalResetSelection. ].
				
	selectionHolder whenChangedDo: [ self changed: #getIndex ].
	self whenSelectedItemChanges: [:item | item value ]! !

!DropListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 14:14'!
internalResetSelection

	self selectionHolder reset.
	self getList isEmpty not
		ifTrue: [ self setSelectedIndex: 1 ]! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:48'!
items: aList

	listHolder contents: aList! !

!DropListModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 13:29'!
listHolder
	
	^ listHolder! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 14:14'!
resetSelection

	self selectionHolder reset! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:37'!
selectedIndex
	"Useless method but it denies a better and more consistent API"

	^ self getIndex! !

!DropListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 13:34'!
selectedIndexHolder

	^ self selectionHolder index! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:45'!
selectedItem

	^ self selectedItemHolder contents! !

!DropListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 13:34'!
selectedItemHolder

	^ self selectionHolder selection! !

!DropListModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 13:29'!
selectionHolder
	
	^ selectionHolder! !

!DropListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 14:45'!
setIndex: anIndex

	self selectionHolder index contents: anIndex.
	self selectionHolder selection contents: (self listHolder contents at: anIndex ifAbsent: [ nil ]).
	self changed: #getIndex! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 14:48'!
setSelectedIndex: anIndex

	| selection |
	selection := self listHolder contents at: anIndex ifAbsent: [ ^ self ].
	selectionHolder index contents: anIndex.
	selectionHolder selection contents: selection! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:46'!
setSelectedItem: anItem

	| index |
	index := self getList identityIndexOf: anItem ifAbsent: [ ^ self ].
	selectionHolder index contents: index.
	selectionHolder selection contents: anItem! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 13:46'!
whenSelectedItemChanges: aBlock

	self selectionHolder selection whenChangedDo: aBlock! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 13:47'!
whenSelectionChanges: aBlock

	self selectionHolder whenChangedDo: aBlock! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 13:47'!
whenSelectionIndexChanges: aBlock

	self selectionHolder index whenChangedDo: aBlock! !

ComposableModel subclass: #ListComposableModel
	instanceVariableNames: 'selectionHolder listHolder wrapHolder menuHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ListComposableModel commentStamp: '<historical>' prior: 0!
A ListComposableModel is an applicative model which handle a basic list.

| t |
t:= ListComposableModel new.
t openWithSpec.
t listHolder contents: (Smalltalk allClasses).
self example!

!ListComposableModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 12/15/2011 13:29'!
example
	| instance |

	instance := self new.
	instance openWithSpec.
	instance listHolder contents: (Smalltalk allClasses).! !

!ListComposableModel class methodsFor: 'specs' stamp: 'SimonAllier 1/27/2012 12:23'!
internSpec

	^ {#PluggableListMorph.
	    		#model:. 				#model.
			#getListSelector:. 		#getList.
			#getIndexSelector:. 	#getIndex.
			#setIndexSelector:. 	#setIndex:.
			#getMenuSelector:.		#menu:shifted:.
			#wrapSelector:. 		#wrapItem:.
			#hResizing:. 			#spaceFill.
			#vResizing:. 			#spaceFill.
			#eventHandler:.		{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!ListComposableModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
selectionHolder: indexHolder listHolder: listHolder

	^ self new
		selectionHolder: indexHolder;
		listHolder: listHolder;
		yourself! !

!ListComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:09'!
title

	^ 'List'! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
getIndex

	^ self selectionHolder index contents! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 1/9/2012 17:47'!
getList

	^ self listHolder contents ifNil: [ {} ]! !

!ListComposableModel methodsFor: 'initialize' stamp: 'SimonAllier 1/27/2012 12:25'!
initialize

	super initialize.
	self selectionHolder: SelectionValueHolder new.
	self listHolder: Array new asValueHolder.
	self wrapHolder: [:object | object asStringOrText ] asValueHolder.
	self menuHolder: [:a :b | nil ] asValueHolder! !

!ListComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 18:42'!
isEventForNextFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<right>'! !

!ListComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 19:34'!
isEventForPreviousFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<left>'! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:48'!
items: aList

	listHolder contents: aList! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
listHolder

	^ listHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 13:51'!
listHolder: anObject

	listHolder := anObject.
	anObject whenChangedDo: [ self changed: #getList ].
	self changed: #getList.
	! !

!ListComposableModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 12:25'!
menu: aBlock

	self menuHolder contents: aBlock! !

!ListComposableModel methodsFor: 'morphic' stamp: 'SimonAllier 1/27/2012 12:24'!
menu: aMenu shifted: aBoolean

	^ self menuHolder contents cull: aMenu cull: aBoolean! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
menuHolder

	^ menuHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
menuHolder: aHolder

	menuHolder := aHolder! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/7/2012 06:44'!
resetSelection

	self selectionHolder reset! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:36'!
selectedIndex
	"Useless method but it denies a better and more consistent API"

	^ self getIndex! !

!ListComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/31/2012 15:49'!
selectedIndexHolder

	^ self selectionHolder index! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 02:15'!
selectedItem

	^ self selectedItemHolder contents! !

!ListComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/16/2012 01:49'!
selectedItemHolder

	^ self selectionHolder selection! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
selectionHolder

	^ selectionHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
selectionHolder: anObject

	selectionHolder := anObject.
	anObject whenChangedDo: [ self changed: #getIndex ].
	self changed: #getIndex.! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
setIndex: anIndex

	self selectionHolder index contents: anIndex.
	self selectionHolder selection contents: (self getList at: anIndex ifAbsent: [ nil ]).
	self changed: #getIndex! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:48'!
setSelectedIndex: anIndex

	| selection |
	selection := self getList at: anIndex ifAbsent: [ ^ self ].
	selectionHolder index contents: anIndex.
	selectionHolder selection contents: selection! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:48'!
setSelectedItem: anItem

	| index |
	index := self getList identityIndexOf: anItem ifAbsent: [ ^ self ].
	selectionHolder index contents: index.
	selectionHolder selection contents: anItem! !

!ListComposableModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 12:09'!
updateList

	self changed: #getList.
	self resetSelection! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 1/16/2012 02:02'!
whenSelectedItemChanges: aBlock

	self selectionHolder selection whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 1/16/2012 02:02'!
whenSelectionChanges: aBlock

	self selectionHolder whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 1/16/2012 02:08'!
whenSelectionIndexChanges: aBlock

	self selectionHolder index whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
wrapHolder

	^ wrapHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
wrapHolder: anObject
	
	wrapHolder := anObject.
	anObject whenChangedDo: [ self changed: #getList ].
	self changed: #getList! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:35'!
wrapItem: anObject

	^ self wrapHolder contents value: anObject! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:47'!
wrappingBlock: aBlock

	wrapHolder contents: aBlock! !

ComposableModel subclass: #MethodBrowser
	instanceVariableNames: 'listModel textModel toolbarModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!MethodBrowser commentStamp: '<historical>' prior: 0!
A MethodBrowser is a simple browser using Spec to display a list of methods and their source code

	si := MethodBrowser new.
	si openWithSpec.
	si methods: Object methodDict values!

!MethodBrowser class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 1/16/2012 23:18'!
example

	| mb |
	mb := MethodBrowser new.
	mb openWithSpec.
	mb methods: Object methodDict values! !

!MethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/18/2012 01:58'!
internSpec

	^{ #PanelMorph.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #listModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@0.5).	(0@0 corner: 0@(-15)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #toolbarModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@0.5).	(0@(-15) corner: 0@15). }}.															
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #textModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@1).	(0@15 corner: 0@0). }}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!MethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/31/2012 13:32'!
internSpec2
^{ #Panel.
		#changeTableLayout.
		#listDirection:. 	#bottomToTop.
		#addMorph:. 		{#model. #listModel. #internSpec.}.
		#addMorph:. 		{#model. #textModel. #internSpec.}.
		#vResizing:.		 #spaceFill.
		#hResizing:.		 #spaceFill.}! !

!MethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/31/2012 13:36'!
title

	^ 'Method Browser'! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:42'!
action

	^ textModel actionToPerformHolder content! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:42'!
action: aBlock

	textModel action: aBlock! !

!MethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 14:36'!
initialize
	"Initialization code for MethodBrowser"

	super initialize.

	listModel := self instantiate: ListComposableModel.
	textModel := self instantiate: TextModel.
	toolbarModel := self instantiate: MethodToolbar.
	
	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel.
	
	listModel whenSelectedItemChanges: [:selection |
		selection
			ifNil: [
				textModel text: ''.
				textModel behavior: nil.
				toolbarModel method: nil ]
			ifNotNil: [:m | 
				textModel text: m sourceCode.
				textModel behavior: m methodClass.
				toolbarModel method: m ]].
	
	self action: [:t | self listModel selectedItem inspect ].
	textModel aboutToStyle: true.
	self wrapWith: [:item | item methodClass name,'>>#', item selector ].! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/15/2012 22:31'!
listHolder

	^ listModel listHolder! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/15/2012 22:31'!
listHolder: anHolder
	
	listModel listHolder: anHolder! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:51'!
listModel

	^ listModel! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/31/2012 13:10'!
methods: aList

	"Here I reroute my entry point to the list model's entry point"
	self listModel items: aList! !

!MethodBrowser methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 03:16'!
takeKeyboardFocus

	^ self listModel takeKeyboardFocus! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:51'!
textModel

	^ textModel! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2012 01:58'!
toolbarModel

	^ toolbarModel! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 23:02'!
wrapWith: aBlock

	listModel wrappingBlock: aBlock! !

ComposableModel subclass: #MethodToolbar
	instanceVariableNames: 'methodHolder browseModel sendersModel versionModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!MethodToolbar commentStamp: '<historical>' prior: 0!
A MethodToolbar is xxxxxxxxx.

b := MethodToolbar new.
b openWithSpec.
b method: (ButtonModel>>#state:).
b method: nil!

!MethodToolbar class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/18/2012 01:14'!
internSpec

	^ { #PanelMorph.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#browseModel.	#internSpec}.
			#addMorph:. {#model.	#sendersModel.	#internSpec}.
			#addMorph:. {#model.	#versionModel.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!MethodToolbar class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/18/2012 01:04'!
title

	^ 'Toolbar'! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/1/2012 18:26'!
addAll: aWindow  withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		fullFrame: (LayoutFrame 
			fractions: (0@0 corner: 1@0) 
			offsets: (0@0 corner: 0@30)).! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2012 01:22'!
browseMethod

	methodHolder contents
		ifNotNil: [:aMethod | aMethod browse ]! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2012 01:17'!
browseModel

	^ browseModel! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/31/2012 13:15'!
initialize
	"Initialization code for MethodToolbar"

	super initialize.

	methodHolder := nil asValueHolder.
	browseModel := self instantiate: ButtonModel.
	sendersModel := self instantiate: ButtonModel.
	versionModel := self instantiate: ButtonModel.

	self setFocusOrder.
	
	self setBrowseModel.
	self setVersionModel.
	self setSendersModel.

	self registerForChanges.! !

!MethodToolbar methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 00:35'!
method: aMethod

	methodHolder contents: aMethod! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:04'!
registerForChanges

	methodHolder whenChangedDo: [:contents || boolean |
		boolean := contents
						ifNil: [ false ]
						ifNotNil: [ true ].
		browseModel state: boolean.
		sendersModel state: boolean.
		versionModel state: boolean.]! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2012 01:21'!
sendersMethod

	methodHolder contents
		ifNotNil: [:aMethod | 
			| strm array |
			strm := (array := Array new: {} size + 1) writeStream.
			strm nextPut: nil.
			strm nextPutAll: {}.

			aMethod ifNil: [ | selector |
				selector := UIManager default request: 'Type selector:' initialAnswer: 'flag:'.
				selector ifNil: [selector := String new].
				selector := selector copyWithout: Character space.
				^ selector isEmptyOrNil ifFalse: [
					(Symbol hasInterned: selector
						ifTrue: [ :aSymbol |
							array at: 1 put: aSymbol.
							self systemNavigation perform: #browseAllCallsOn: withArguments: array])
						ifFalse: [ self inform: 'no such selector']
				]
			].

			array at: 1 put: aMethod selector.
			self systemNavigation perform: #browseAllCallsOn: withArguments: array]! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2012 01:17'!
sendersModel

	^ sendersModel! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:13'!
setBrowseModel
	
	browseModel
		state: false;
		label: 'Browse';
		action: [ self browseMethod ].
	
! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 00:36'!
setFocusOrder

	self focusOrder
		add: browseModel;
		add: sendersModel;
		add: versionModel.
		! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:18'!
setSendersModel
	
	sendersModel
		state: false;
		label: 'Senders';
		action: [ self sendersMethod ].
	
! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:13'!
setVersionModel
	
	versionModel
		state: false;
		label: 'Version';
		action: [ self versionMethod ].
	
! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2012 01:22'!
versionMethod

	methodHolder contents
		ifNotNil: [:aMethod | 
			| selector class | 
	(selector := aMethod selector)
		ifNil: [ self inform: 'Sorry, only actual methods have retrievable versions.'. ^nil ]
		ifNotNil: [
			class := aMethod methodClass.
			(VersionsBrowser
				browseVersionsOf: aMethod
				class: class
				meta: class isMeta
				category: aMethod category
				selector: selector)]]! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2012 01:17'!
versionModel

	^ versionModel! !

ComposableModel subclass: #RadioButtonGroupExample
	instanceVariableNames: 'button1 button2 button3 container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!RadioButtonGroupExample commentStamp: '<historical>' prior: 0!
A RadioButtonGroupExample is an simple example about how to use RadioButtons and RadioGroup!

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 00:45'!
internSpec

	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		self topSpec.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	(0@0 corner: 1@0).	(0@0 corner: 0@20). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #container.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@1).	(0@22 corner: 0@0). }}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 00:34'!
internSpec2

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.	#internSpec}.
			#addMorph:. {#model.	#button2.	#internSpec}.
			#addMorph:. {#model.	#button3.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/1/2012 17:51'!
title

	^ 'Radio Button Group Example'! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 00:38'!
topSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.	#internSpec}.
			#addMorph:. {#model.	#button2.	#internSpec}.
			#addMorph:. {#model.	#button3.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button1

	^ button1! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button2

	^ button2! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button3

	^ button3! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 00:39'!
container

	^ container! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:59'!
initialize
	"Initialization code for RadioButtonGroupExample"

	super initialize.

	self instantiateButtons.
	container := PanelMorph new.
	
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	self instantiateMorphs.
	self setFocus.
	self setActions.
	self setGroup.
	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:55'!
instantiateButtons

	button1 := self instantiate: RadioButtonModel.
	button2 := self instantiate: RadioButtonModel.
	button3 := self instantiate: RadioButtonModel.
	
	button1 label: 'Button 1'.
	button2 label: 'Button 2'.
	button3 label: 'Button 3'.! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:00'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:50'!
setActions

	self setActionsForButton1.
	self setActionsForButton2.
	self setActionsForButton3.	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton1

	button1 whenActivatedDo: [ container addMorph: morph1 ].
	button1 whenDesactivatedDo: [ container removeMorph: morph1 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton2

	button2 whenActivatedDo: [ container addMorph: morph2 ].
	button2 whenDesactivatedDo: [ container removeMorph: morph2 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton3

	button3 whenActivatedDo: [ container addMorph: morph3 ].
	button3 whenDesactivatedDo: [ container removeMorph: morph3 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:47'!
setFocus
	
	self focusOrder
		add: button1;
		add: button2;
		add: button3.
	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:49'!
setGroup

	RadioButtonGroup new 
		addRadioButton: button1;
		addRadioButton: button2;
		addRadioButton: button3;
		default: button1.
	! !

ComposableModel subclass: #RadioButtonModel
	instanceVariableNames: 'actionWhenActivatedHolder actionWhenDesactivatedHolder enabledHolder stateHolder label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!RadioButtonModel commentStamp: '<historical>' prior: 0!
A RadioButtonModel is a spec model for RadioButton

!! The method privateSetState: is really private and should only be used by RadioButtonGroup !!

You can also have a look at RadioButtonGroupExample for a full example of how to use them with a group.!

!RadioButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 13:07'!
internSpec

	^ {#Checkbox.
	    		#on:selected:changeSelected:. 	#model. #state. #state:.
			#label:.								{	#model. #label		}.
			#beRadioButton.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!RadioButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/1/2012 13:35'!
title

	^ 'Radio Button'! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
actionWhenActivatedHolder
	
	^ actionWhenActivatedHolder! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
actionWhenDesactivatedHolder
	
	^ actionWhenDesactivatedHolder! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 17:44'!
activationAction: aBlock

	"This method is used to set the action to perform when I am activated"
	self actionWhenActivatedHolder contents: aBlock! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 17:44'!
desactivationAction: aBlock

	"This method is used to set the action to perform when I am desactivated"
	self actionWhenDesactivatedHolder contents: aBlock! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 13:27'!
enabled: aBoolean

	self enabledHolder contents: aBoolean! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
enabledHolder
	
	^ enabledHolder! !

!RadioButtonModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/1/2012 17:39'!
initialize
	"Initialization code for RadioButton"

	super initialize.
	
	actionWhenActivatedHolder := [] asValueHolder.
	actionWhenDesactivatedHolder := [] asValueHolder.
	enabledHolder := true asValueHolder.
	stateHolder := true asValueHolder.
	stateHolder whenChangedDo: [:bool |
		bool
			ifTrue: actionWhenActivatedHolder contents
			ifFalse: actionWhenDesactivatedHolder contents ].! !

!RadioButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/1/2012 18:03'!
isEventForNextFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<right>'! !

!RadioButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/1/2012 18:03'!
isEventForPreviousFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<left>'! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:57'!
label
	
	^ label! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 17:56'!
label: aString

	label := aString.
	self morph
		ifNotNil: [:m | m label: label ]! !

!RadioButtonModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 00:57'!
privateSetState: aBoolean

	self stateHolder contents: aBoolean.
	self changed: #state! !

!RadioButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/1/2012 13:44'!
state

	^ self stateHolder contents! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 14:03'!
state: aBoolean

	self state
		ifFalse: [ self stateHolder contents: true ].! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
stateHolder
	
	^ stateHolder! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/1/2012 18:00'!
whenActivatedDo: aBlock

	"This method is used to propagate the event that I have been activated" 
	self stateHolder whenChangedDo: [:bool | bool ifTrue: aBlock ]! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/1/2012 18:00'!
whenDesactivatedDo: aBlock

	"This method is used to propagate the event that I have been desactivated"
	self stateHolder whenChangedDo: [:bool | bool ifFalse: aBlock ]! !

ComposableModel subclass: #SendersBrowser
	instanceVariableNames: 'listModel textModel listHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Browsers'!

!SendersBrowser commentStamp: '<historical>' prior: 0!
A SendersBrowser is a UI used to browse senders and implementors

Basically, it's composed of a list used to browse methods, and of a text pane used to see the source code of the selected method!

!SendersBrowser classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/12/2012 19:22'!
internSpec

	^ {#PanelMorph.
			#changeTableLayout.
			#listDirection:.	#bottomToTop.
			#addMorph:.	{#model.	#listModel.		#internSpec}.
			#addMorph:.	{#model.	#textModel.	#internSpec}.}! !

!SendersBrowser classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/12/2012 19:23'!
title

	^ 'Senders/Implementors'! !

!SendersBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/15/2012 22:29'!
initialize
	"Initialization code for SendersBrowser"
	| linkHolder behaviorHolder |

	super initialize.
	
	listHolder := {} asValueHolder.
	listModel := ListComposableModel new.
	listModel listHolder: listHolder.
	textModel := TextModel new.
	
	linkHolder := ComposableValueHolder on: listModel selectionHolder do: [:index :selection | 
		selection contents 
			ifNil: [ '' ] 
			ifNotNil: [:method | method sourceCode ]].
		
	behaviorHolder := ComposableValueHolder on: listModel selectionHolder do: [:index :selection | 
		selection contents 
			ifNil: [ nil ] 
			ifNotNil: [:method | method methodClass ]].
		
	textModel textHolder: linkHolder.
	textModel behaviorHolder: behaviorHolder.
	textModel aboutToStyleHolder contents: true.! !

!SendersBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/12/2012 19:23'!
listHolder

	^ listHolder! !

!SendersBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/12/2012 19:45'!
listHolder: anHolder

	listHolder := anHolder.
	self listModel listHolder: anHolder.! !

!SendersBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/12/2012 19:23'!
listModel

	^ listModel! !

!SendersBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/12/2012 19:23'!
textModel

	^ textModel! !

ComposableModel subclass: #TestingComposableModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!TestingComposableModel commentStamp: '<historical>' prior: 0!
A TestingComposableModel is a stupid composable model used to test SpecInterpreter!

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/19/2012 16:43'!
internSpec

	^ {#List.
		#model:.	#model.}! !

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/19/2012 17:35'!
testingSpec

	^ {#Text.
		#model:.	#model.}! !

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/19/2012 16:43'!
title

	^ 'You should not see me !!'! !

ComposableModel subclass: #TextFieldExample
	instanceVariableNames: 'methodBrowser textField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!TextFieldExample commentStamp: '<historical>' prior: 0!
A TextFieldExample is a simple example of how to use TextFields.!

!TextFieldExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 14:54'!
internSpec
	| textFieldHeight |
	textFieldHeight := StandardFonts defaultFont height + 15.
	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #textField. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 ( 0@0 corner: 1@0 ).	(0@0 corner: 0@textFieldHeight). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #methodBrowser. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	( 0@0 corner: 1@1 ).	(0@textFieldHeight corner: 0@0). }}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!TextFieldExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
title

	^ 'Text Field Example'! !

!TextFieldExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 14:43'!
initialize
	"Initialization code for TextFieldExample"

	super initialize.

	methodBrowser := self instantiate: MethodBrowser.
	textField := self instantiate: TextInputFieldModel.
	
	textField 
		ghostText: 'Enter a class name';
		autoAccept: true;
		action: [:text | Smalltalk globals at: text asSymbol
								ifPresent: [:class | methodBrowser methods: class methodDict values ]
								ifAbsent: [ methodBrowser methods: {} ]]! !

!TextFieldExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
methodBrowser

	^ methodBrowser! !

!TextFieldExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
textField

	^ textField! !

ComposableModel subclass: #TextInputFieldModel
	instanceVariableNames: 'textHolder actionToPerformHolder ghostText alwaysAccept acceptOnCR autoAccept entryCompletion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!TextInputFieldModel commentStamp: '<historical>' prior: 0!
A TextInputFieldModel is a spec model for TextInputField.!

!TextInputFieldModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/4/2012 14:46'!
example
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance ghostText: 'This is a ghost'.
	instance text: 'This is a text'! !

!TextInputFieldModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 14:47'!
internSpec

	^ {#TextField.
			#convertTo:. 							String.
			#on:text:accept:readSelection:menu:. 	#model. #getText. #accept:. nil. nil.
			#entryCompletion:. 				{	#model. #entryCompletion	}.
			#autoAccept:.						{	#model. 	#autoAccept			}.	
			#acceptOnCR:. 					{	#model. 	#acceptOnCR			}.
			#ghostText:.						{	#model. 	#ghostText			}.
			#hResizing:. 							#spaceFill.
			#vResizing:. 							#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!TextInputFieldModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
title

	^ 'Text'! !

!TextInputFieldModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
accept: aText

	self textHolder contents: aText.
	self actionToPerformHolder contents cull: aText.
	self changed: #clearUserEdits.! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:21'!
acceptOnCR

	^ acceptOnCR! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:21'!
acceptOnCR: aBoolean

	acceptOnCR := aBoolean
	self morph ifNotNil: [:m | m acceptOnCR: acceptOnCR ]! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:36'!
action: aBlockWithOneArgument

	actionToPerformHolder contents: aBlockWithOneArgument! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
actionToPerformHolder

	^ actionToPerformHolder! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:23'!
autoAccept

	^ autoAccept! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:25'!
autoAccept: aBoolean

	autoAccept := aBoolean.
	self morph ifNotNil: [:m | m autoAccept: autoAccept ]! !

!TextInputFieldModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
defaultEntryCompletion

	| applicants |
	applicants := (Array
				streamContents: [:strm | Symbol
						allSymbolTablesDo: [:each | (each notEmpty
									and: [each first canBeGlobalVarInitial
											and: [Smalltalk globals includesKey: each]])
								ifTrue: [strm nextPut: each]]]) sort.

	^ EntryCompletion new
				dataSourceBlock: [:currText | applicants];
				filterBlock: [:currApplicant :currText | currText size > 3
						and: [currApplicant asUppercase includesSubString: currText asString asUppercase]].! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
entryCompletion

	^ entryCompletion! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
entryCompletion: anEntryCompletion

	entryCompletion := anEntryCompletion.
	self morph ifNotNil: [:m | m entryCompletion: entryCompletion ]! !

!TextInputFieldModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/4/2012 11:20'!
getText
	
	^ self textHolder contents! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 12:02'!
ghostText

	^ ghostText! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 11:37'!
ghostText: aText

	ghostText := aText translated.
	self morph ifNotNil: [:m | m ghostText: ghostText ]! !

!TextInputFieldModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 14:24'!
initialize
	"Initialization code for TextComposableModel"

	super initialize.

	self textHolder: '' asValueHolder.
	actionToPerformHolder := [:text | ] asValueHolder.
	
	ghostText := ''.
	acceptOnCR := true.
	autoAccept := false.! !

!TextInputFieldModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
isEventForNextFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<Ctrl-Cmd-right>'! !

!TextInputFieldModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
isEventForPreviousFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<Ctrl-Cmd-left>'! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
removeEntryCompletion

	self entryCompletion: nil! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
setSelection: anInterval

	self morph setSelection: anInterval! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
text: aText

	textHolder contents: aText! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
textHolder

	^ textHolder! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
textHolder: anObject
	
	textHolder := anObject.
	anObject whenChangedDo: [ self changed: #getText ].
	self changed: #getText.! !

ComposableModel subclass: #TextModel
	instanceVariableNames: 'aboutToStyleHolder behaviorHolder textHolder actionToPerformHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!TextModel commentStamp: '<historical>' prior: 0!
A TextComposableModel is an applicative model which handle a basic text.

| t |
t:= TextComposableModel new.
t openWithSpec.
t textHolder contents: 'This is a test'.

self example!

!TextModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/4/2012 14:46'!
example
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance text: 'This is a test'.! !

!TextModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/23/2012 19:14'!
internSpec

	^ {#PluggableTextMorph.
	    		#on:text:accept:readSelection:menu:. 	#model. #getText. #accept:. nil. nil.
			#hResizing:. 							#spaceFill.
			#vResizing:. 							#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!TextModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/13/2011 23:31'!
title

	^ 'Text'! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 22:59'!
aboutToStyle: aBoolean	

	aboutToStyleHolder contents: [ aBoolean ]! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 22:58'!
aboutToStyleBlock: aBlockReturningABoolean	

	aboutToStyleHolder contents: aBlockReturningABoolean! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:06'!
aboutToStyleHolder

	^ aboutToStyleHolder! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:06'!
aboutToStyleHolder: aValueHolder

	aboutToStyleHolder := aValueHolder.
	aValueHolder whenChangedDo: [ self changed: #getText ].
	self changed: #getText.! !

!TextModel methodsFor: 'morphic' stamp: 'SimonAllier 1/27/2012 11:50'!
accept: aText

	self textHolder contents: aText.
	self actionToPerformHolder contents cull: aText.
	self changed: #clearUserEdits.! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:36'!
action: aBlockWithOneArgument

	actionToPerformHolder contents: aBlockWithOneArgument! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:08'!
actionToPerformHolder

	^ actionToPerformHolder! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:10'!
actionToPerformHolder: aValueHolder

	actionToPerformHolder := aValueHolder.! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 02:15'!
behavior: aText

	behaviorHolder contents: aText! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
behaviorHolder

	^ behaviorHolder! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/3/2012 17:11'!
behaviorHolder: aValueHolder
	
	behaviorHolder := aValueHolder.
	aValueHolder whenChangedDo: [ 
		self morph ifNotNil: [:mrph | mrph classOrMetaClass: aValueHolder contents ].
		self changed: #getText ].
	self morph ifNotNil: [:mrph | mrph classOrMetaClass: aValueHolder contents ].
	self changed: #getText! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:17'!
doItContext

	^ nil! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:17'!
doItReceiver

	^ self selectedBehavior
		ifNil: [ nil ]
		ifNotNil: [:class | class theNonMetaClass ]! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 17:26'!
getText
	
	^ self textHolder contents! !

!TextModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/16/2012 00:07'!
initialize
	"Initialization code for TextComposableModel"

	super initialize.

	self textHolder: '' asValueHolder.
	self behaviorHolder: nil asValueHolder.
	self aboutToStyleHolder: [ false ] asValueHolder.
	actionToPerformHolder := [:text | ] asValueHolder.! !

!TextModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/23/2012 19:14'!
isEventForNextFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<Ctrl-Cmd-right>'! !

!TextModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/23/2012 19:08'!
isEventForPreviousFocus: aKeyboardEvent

	^ aKeyboardEvent keyString = '<Ctrl-Cmd-left>'! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:09'!
okToStyle

	^ true! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:14'!
selectedBehavior

	^ self behaviorHolder contents! !

!TextModel methodsFor: 'protocol' stamp: 'SimonAllier 1/24/2012 16:58'!
setSelection: anInterval

	self morph setSelection: anInterval! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:21'!
shoutAboutToStyle: aMorph
	
	^ self aboutToStyleHolder contents value! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/15/2012 23:26'!
text: aText

	textHolder contents: aText! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
textHolder

	^ textHolder! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
textHolder: anObject
	
	textHolder := anObject.
	anObject whenChangedDo: [ self changed: #getText ].
	self changed: #getText.! !

Object subclass: #DropListItem
	instanceVariableNames: 'actionHolder label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!DropListItem commentStamp: '<historical>' prior: 0!
A DropListItem is an item (wrapper) designed to fit into a DropList!

!DropListItem class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/2/2012 15:17'!
example

	| b |
	b:= DropListModel new.
	b openWithSpec.
	b items: { 	DropListItem named: 'label 1' do: [:label | label inspect ].
				DropListItem named: 'label 2' do: [:label | label inspect ].
				DropListItem named: 'label 3' do: [:label | label inspect ].
				DropListItem named: 'label 4' do: [:label | label inspect ]}.

	b whenSelectedItemChanges: [:item | item inspect ]! !

!DropListItem class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/2/2012 14:51'!
named: label do: aBlock

	^ self new
		action: aBlock;
		label: label;
		yourself! !

!DropListItem methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 14:51'!
action: aBlock

	self actionHolder contents: aBlock! !

!DropListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 14:43'!
actionHolder
	
	^ actionHolder! !

!DropListItem methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 14:50'!
initialize
	"Initialization code for DropListItem"

	super initialize.

	actionHolder := [] asValueHolder.
	label := ''.! !

!DropListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 14:43'!
label
	
	^ label! !

!DropListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 14:43'!
label: anObject
	
	label := anObject! !

!DropListItem methodsFor: 'execution' stamp: 'BenjaminVanRyseghem 2/2/2012 14:52'!
value
	"This way, I am polymorphic with nil"

	self actionHolder contents cull: self label cull: self! !

Object subclass: #MorphWrapper
	instanceVariableNames: 'layout morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!MorphWrapper commentStamp: '<historical>' prior: 0!
A MorphWrapper is used to wrap a morph with a layout in the goal to be easily added to another morph!

!MorphWrapper class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: morph layout: layout 

	^ self new
		layout: layout;
		morph: morph;
		yourself! !

!MorphWrapper methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 11/14/2011 16:31'!
addIn: aContainer

	aContainer
		addMorph: morph
		fullFrame: layout! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
frame: relFrame
	| frame |
	frame := LayoutFrame new.
	frame 
		leftFraction: relFrame left; 
		rightFraction: relFrame right; 
		topFraction: relFrame top; 
		bottomFraction: relFrame bottom.
	layout := frame! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
fullFrame: anObject
	
	layout := anObject! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: anObject
	
	morph := anObject! !

Object subclass: #NewValueHolder
	instanceVariableNames: 'announcer contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!NewValueHolder commentStamp: '<historical>' prior: 0!
A NewValueHolder is a new implementation of ValueHolder based on Announcements!

NewValueHolder subclass: #ComposableValueHolder
	instanceVariableNames: 'block originalValueHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ComposableValueHolder commentStamp: '<historical>' prior: 0!
A ComposableValueHolder is a value holder based on another value holder which content is calculated regarding the original value holder content!

!ComposableValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
on: originalValueHolder do: block

	^ self new
		block: block;
		originalValueHolder: originalValueHolder;
		yourself! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block

	^ block! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block: anObject
	
	block := anObject! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
originalValueHolder

	^ originalValueHolder! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
originalValueHolder: aValueHolder
	
	originalValueHolder := aValueHolder.
	aValueHolder whenChangedSend: #updateContents to: self.
	self update: #update! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:57'!
updateContents

	| args |
	args := self originalValueHolder contents.
	args isArray
		ifTrue: [ self contents: (self block valueWithArguments: args)]
		ifFalse: [ self contents: (self block value: args)].! !

!NewValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:28'!
contents: contents

	^ self new
		contents: contents;
		yourself! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 11/28/2011 09:31'!
addDependent: aDependent

	self halt: 'Former API, should be changed'.! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:23'!
contents

	^ contents! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:35'!
contents: anObject
	
	| oldValue |
	oldValue := contents.
	contents := anObject.
	self contentsChanged: oldValue.! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:24'!
contentsChanged
	
	announcer announce: (ValueChanged newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:24'!
contentsChanged: oldValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 01:10'!
initialize

	super initialize.
	
	announcer := Announcer new! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 1/16/2012 01:53'!
whenChangedDo: aBlock

	| block |
	block := [ aBlock cull: self contents ].
	announcer on: ValueChanged do: block! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
whenChangedSend: aSelector to: aReceiver

	announcer on: ValueChanged send: aSelector to: aReceiver! !

NewValueHolder subclass: #SelectionValueHolder
	instanceVariableNames: 'index selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!SelectionValueHolder commentStamp: '<historical>' prior: 0!
A SelectionValueHolder is a value holder especially designed to contains a list selection (an index + an object)!

!SelectionValueHolder class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 21:00'!
index: indexValueHolder selection: selectionValueHolder

	^ self new
		index: indexValueHolder;
		selection: selectionValueHolder;
		yourself! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:09'!
contents

	^ {index. selection}! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
index

	^ index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:59'!
index: anIndex

	index := anIndex.
	self changed: #index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
initialize

	super initialize.
	index := 0 asValueHolder.
	selection := nil asValueHolder.
	
	index whenChangedSend: #contentsChanged to: self.
	selection whenChangedSend: #contentsChanged to: self.! !

!SelectionValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:58'!
reset

	self index contents: 0.
	self selection contents: nil.
	self contentsChanged! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
selection

	^ selection! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:58'!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

!Object methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/28/2011 09:29'!
asValueHolder

	^ NewValueHolder contents: self! !

Object subclass: #RadioButtonGroup
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!RadioButtonGroup commentStamp: '<historical>' prior: 0!
A RadioButtonGroup is a group for radio buttons which ensure that only radio button of this group is activated at the same time.!

!RadioButtonGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:02'!
addRadioButton: aButton

	buttons do: [:b | 
		aButton whenActivatedDo: [ b privateSetState: false ].
		b whenActivatedDo: [ aButton privateSetState: false ]].
		
	buttons add: aButton.
	aButton privateSetState: false! !

!RadioButtonGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:03'!
default: aButton

	aButton privateSetState: true.
	aButton takeKeyboardFocus.! !

!RadioButtonGroup methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/1/2012 17:35'!
initialize
	"Initialization code for RadioButtonGroup"

	super initialize.

	buttons := OrderedCollection new.! !

Object subclass: #SpecInterpreter
	instanceVariableNames: 'instance bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

SpecInterpreter class
	instanceVariableNames: 'Bindings'!

!SpecInterpreter commentStamp: '<historical>' prior: 0!
#model is a magic world to swap the symbol to the model object
!

SpecInterpreter class
	instanceVariableNames: 'Bindings'!

!SpecInterpreter class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:33'!
bindings

	^ Bindings ifNil: [ self initializeBindings. ^ Bindings ]! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:39'!
buildMorphFor: aComposableModel
	
	^ self new buildMorphFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:40'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self new buildMorphFor: aComposableModel withSpec: aSymbol! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:40'!
buildWindowFor: aComposableModel
	
	^ self new buildWindowFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/30/2012 17:02'!
initialize

	super initialize.
	
	SystemBrowser registeredClasses do:[:each | each addGroupForPackage: self package ]! !

!SpecInterpreter class methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 14:29'!
initializeBindings

	Bindings := Dictionary new.

	Bindings
		at: #List put: #PluggableListMorph;
		at: #Text put: #PluggableTextMorph;
		at: #Button put: #PluggableButtonMorph;
		at: #Panel put: #PanelMorph;
		at: #Checkbox put: #CheckboxMorph;
		at: #DropList put: #DropListMorph;
		at: #TextField put: #PluggableTextFieldMorph! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:36'!
interpretASpec: aSpec model: aModel
	
	^ self new	interpretASpec: aSpec model: aModel! !

!SpecInterpreter class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:34'!
resetBindings

	Bindings := nil! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
bindings
	
	^ bindings! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/19/2012 17:19'!
buildMorphFor: aComposableModel
	
	^ self buildMorphFor: aComposableModel withSpec: #internSpec! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/19/2012 17:19'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self interpretASpec: (aComposableModel class perform: aSymbol) model: aComposableModel! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/19/2012 16:38'!
buildWindowFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class windowSpec model: aComposableModel! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
classKeys

	^ Smalltalk keys, self bindings keys! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
convertSymbolOfClassToInstance: aSymbol

	| symbol |
	symbol := self bindings at: aSymbol ifAbsent: [ aSymbol ].

	^ (Smalltalk at: symbol) new! !

!SpecInterpreter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
initialize
	"Initialization code for SpecInterpreter"

	super initialize.

	bindings := self class bindings.
	instance := nil.! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:25'!
instance

	^ instance! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:25'!
instance: anObject
	
	instance := anObject! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 2/4/2012 11:35'!
interpretASpec: aSpec model: aModel
	| index |

	aSpec ifNil: [ ^ nil ].
	(aSpec isCollection and: [aSpec isSequenceable]) ifFalse: [ ^ aSpec ].
	(aSpec isString or: [ aSpec isText ]) ifTrue: [ 
			^ aSpec == #model
				ifTrue: [ aModel ]
				ifFalse: [ 
					(self classKeys identityIncludes: aSpec)
						ifTrue: [ self convertSymbolOfClassToInstance: aSpec ]
						ifFalse: [ aSpec ]]].

	" aSpec is an Array "
	instance := self class interpretASpec: aSpec first model: aModel.
	index := 2.	
	
	[ index <= aSpec size ]
		whileTrue: [ | selector numArgs args newInstance result |
			selector := aSpec at: index.
			numArgs := selector numArgs.
			args := aSpec copyFrom: index + 1 to: index + numArgs.
			args := args collect: [:each | self class interpretASpec: each model: aModel].
			index := index + numArgs + 1.
			newInstance := instance perform: selector withArguments: args.
			index > aSpec size
				ifTrue: [
					aModel morph: instance.
					^ self interpretASpec: newInstance model: instance ].
			instance := newInstance].
	"If you get here, there is a problem. Must probably it comes from the Spec which is wrongly defined"
	self assert: false.
	^ instance! !

Object subclass: #TabClassical
	instanceVariableNames: 'container tab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!TabClassical commentStamp: '<historical>' prior: 0!
A TabClassical is an example to learn how to use tabs ;)!

!TabClassical class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/5/2012 18:33'!
associations: associations

	^ self new
		addTabs: associations;
		yourself.! !

!TabClassical class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 1/5/2012 18:39'!
example

	| tc testMorph model anotherMorph associations |
	
	model := ClassMethodBrowser new.
	
	testMorph := model buildWithSpec: #internSpec.
	anotherMorph := model buildWithSpec: #internSpec2.
	
	associations := {'Test' -> testMorph. 'Another'-> anotherMorph}.
	tc := self associations: associations.
	
	model listHolder contents: (Smalltalk allClasses).
	tc open.! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/7/2012 05:59'!
addAll: window
	
	window
		addMorph: tab
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ 35)).
				
	window
		addMorph: container
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 35 corner: 0 @ 0)).
				
	tab tabs size = 0 ifTrue: [ ^ self ].
	tab color: Color white darker darker! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/15/2012 22:13'!
addTabs: associations

	associations do: [:each |
		self tab 
			addTab: (Text fromString: each key) 
			withAction: [ 	self setMorph: each value ].
		container submorphs isEmpty ifTrue: [ container addMorph: each value ]]! !

!TabClassical methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/5/2012 18:30'!
initialize
	"Initialization code for TabClassical"

	super initialize.

	container := PanelMorph new changeTableLayout; listDirection: #bottomToTop; color: Color white; yourself.
	tab := PluggableTabBarMorph on: self.
	tab width: 150.! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/5/2012 18:21'!
open

	| window panel |
	window := StandardWindow new.
	panel := PanelMorph new hResizing: #spaceFill; vResizing: #spaceFill; changeProportionalLayout.

	window addMorph: panel frame: (0@0 corner: 1@1).
	self addAll: panel.
	window openInWorld.
	
	window title: 'Tab Test'! !

!TabClassical methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/3/2012 18:59'!
setMorph: aMorph

	container removeAllMorphs.
	container addMorph: aMorph.
	aMorph color: Color white.
	aMorph takeKeyboardFocus.! !

!TabClassical methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/3/2012 19:02'!
tab

	^ tab! !
SpecInterpreter initialize!
